import datetime
import logging

from odoo import _, api, fields, models
from odoo.exceptions import UserError
from odoo.tools.misc import format_date

logger = logging.getLogger(__name__)


class TaxReceiptAnnualCreate(models.TransientModel):
    _inherit = "tax.receipt.annual.create"

    @api.model
    def _prepare_annual_tax_receipt(self, partner, partner_dict):
        vals = {
            "company_id": self.company_id.id,
            "currency_id": self.company_id.currency_id.id,
            "amount": partner_dict["amount"],
            "type": "annual",
            "partner_id": partner.id,
            "date": self.end_date,
            "donation_date": self.end_date,
        }
        # designed to add add O2M fields donation_ids and invoice_ids
        vals.update(partner_dict["extra_vals"])
        return vals

